#include "blocks.h"
#include "global.h"
#include "functions.h"
#include "regs.h"

int numsections=0;
long new_gp;
long new_bss_start;
long new_text_start;
long new_data_start;
long new_bsize;
long new_tsize;
long new_dsize;
long old_text_start;
long old_data_start;
long old_bss_start;
long old_bsize;
long old_tsize;
long old_dsize;
long dead_lita_size;
ADDRESS dead_const_data;

long gap;

MAP_BLOCK** indirect_blockmap1;
ADDRESS indirect_blockmap_start1;
INT64 indirect_blockmap_size1;

MAP_BLOCK** indirect_blockmap2;
ADDRESS indirect_blockmap_start2;
INT64 indirect_blockmap_size2;

INDEX* indirect_sectionmap1 = 0;
ADDRESS indirect_section_start1;
INT64 indirect_section_size1;

INDEX* indirect_sectionmap2 = 0;
ADDRESS indirect_section_start2;
INT64 indirect_section_size2;

/********************************************************
 Locate Blocks doing a linear search over the block_maps
 ********************************************************/

MAP_BLOCK * EarlyLocateBlock(ADDRESS address)
{
  int tel;
  MAP_BLOCK * tmp;

  for (tel=0; tel<numsections; tel++)
    {
#if 1
      if (
	  (address>=map_sections[tel].new_start && address<map_sections[tel].new_start+map_sections[tel].new_size) ||
	  (address>=map_sections[tel].dead_start && address<map_sections[tel].dead_start+map_sections[tel].dead_size)
	  )
#endif
	for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	  {
	    if ((address-tmp->new_start)>=0)
	      if ((address-tmp->new_start)<tmp->size)
		{
		  return tmp; 
		}
	  }
    }
  //  printf("Locate Block : niet gevonden %lx !!!!!\n",address);
  return NULL;
}

/********************************************************
 An indirect map is build that given an address returns
 the datablock directly
 ********************************************************/

extern void BuildIndirectMap()
{
  int teller;
  BOOL   verbose = HasOption(PRINT_OPT_VERBOSE,"Indirectmap");

  ADDRESS start1=0x120000000L;
  ADDRESS end1=0L;
  ADDRESS start2=new_data_start;
  ADDRESS end2=0L;

  for (teller=0;teller<numsections;teller++)
    {
      if (map_sections[teller].dead_start<=start1 && map_sections[teller].dead_start>0)
	start1 = map_sections[teller].dead_start;

      if (map_sections[teller].new_start<=start2 && map_sections[teller].new_start>0 && map_sections[teller].new_start>0x130000000L)
	start2 = map_sections[teller].new_start;

      if (map_sections[teller].dead_size>0)
	if (map_sections[teller].dead_start+map_sections[teller].dead_size>end1)
	  end1 = map_sections[teller].dead_start+map_sections[teller].dead_size;

      if (map_sections[teller].new_size>0 && map_sections[teller].new_start>0x135000000L)
	if (map_sections[teller].new_start+map_sections[teller].new_size>end2)
	  end2 = map_sections[teller].new_start+map_sections[teller].new_size;

      if (map_sections[teller].dead_size==0)
	if (map_sections[teller].start+map_sections[teller].size<new_data_start)
	  if (map_sections[teller].start+map_sections[teller].size>end1)
	    end1 = map_sections[teller].start+map_sections[teller].size;

      if (map_sections[teller].new_size==0 && map_sections[teller].new_start>0x135000000L)
	  if (map_sections[teller].new_start+map_sections[teller].new_size>end2)
	    end2 = map_sections[teller].new_start+map_sections[teller].new_size;
    }

  if (end2>new_data_start+new_dsize)
    end2=new_data_start+new_dsize;

  indirect_section_size1 = end1-start1;
  indirect_section_start1 = start1; 
  indirect_sectionmap1 = (INDEX*) malloc(sizeof(INDEX)*(indirect_section_size1)/8);

  indirect_section_size2 = end2-start2;
  indirect_section_start2 = start2; 
  indirect_sectionmap2 = (INDEX*) malloc(sizeof(INDEX)*(indirect_section_size2)/8);

  indirect_blockmap_size1 = end1-start1;
  indirect_blockmap_start1 = start1;
  indirect_blockmap1 = (MAP_BLOCK**) malloc (sizeof(ADDRESS)*(indirect_blockmap_size1)/8);
 
  indirect_blockmap_size2 = end2-start2;
  indirect_blockmap_start2 = start2;
  indirect_blockmap2 = (MAP_BLOCK**) malloc (sizeof(ADDRESS)*(indirect_blockmap_size2)/8);
 
  if (verbose)
    {  
      printf("start1 : %lx\n",start1);
      printf("size1:   %lx\n",indirect_blockmap_size1);
      printf("start2 : %lx\n",start2);
      printf("size2:   %lx\n",indirect_blockmap_size2);
    }
  
  for (teller=0;teller<indirect_blockmap_size1/8;teller++)
    {
      indirect_blockmap1[teller]=EarlyLocateBlock(start1+teller*8);
    }

  for (teller=0;teller<indirect_blockmap_size2/8;teller++)
    {
      indirect_blockmap2[teller]=EarlyLocateBlock(start2+teller*8);  
    }

  for (teller=0;teller<indirect_blockmap_size1/8;teller++)
    {
      indirect_sectionmap1[teller]=EarlyLocateSection(start1+teller*8);
    }

  for (teller=0;teller<indirect_blockmap_size2/8;teller++)
    {
      indirect_sectionmap2[teller]=EarlyLocateSection(start2+teller*8);
    }

  InfoStatus(stdout,"\t[BuildIndirectMap]\n");
  
}
/********************************************************
 Locate a block using the indirection through the address-block
 map
 ********************************************************/


extern MAP_BLOCK * LocateBlockIndirect(ADDRESS address)
{
  if (address>=indirect_blockmap_start1 && address<indirect_blockmap_start1+indirect_blockmap_size1)
    return indirect_blockmap1[(address-indirect_blockmap_start1)/8];
  if (address>=indirect_blockmap_start2 && address<indirect_blockmap_start2+indirect_blockmap_size2)
    return indirect_blockmap2[(address-indirect_blockmap_start2)/8];
  else return NULL;
}

/********************************************************
 Find the datablock containing an address
 ********************************************************/

extern MAP_BLOCK * LocateBlock(ADDRESS address)
{
  int tel;
  MAP_BLOCK * tmp;
  if (address<=indirect_blockmap_start1+indirect_blockmap_size1 || address<=indirect_blockmap_start2+indirect_blockmap_size2)
    if ((tmp = LocateBlockIndirect(address)))
      {
	return tmp;
      }
  
  for (tel=0; tel<numsections; tel++)
    {
#if 1
      if (
	  (address>=map_sections[tel].start && address<map_sections[tel].start+map_sections[tel].size) ||
	  (address>=map_sections[tel].dead_start && address<map_sections[tel].dead_start+map_sections[tel].dead_size)
	  )
#endif
	for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	  {
	    if ((address-tmp->start)>=0)
	      if ((address-tmp->start)<tmp->size)
		{
		  return tmp; 
		}
	  }
    }
  //  printf("Locate Block : niet gevonden %lx !!!!!\n",address);
  return NULL;
}

/********************************************************
 Find the original block containing an address
 ********************************************************/
MAP_BLOCK * LocateOriginalBlock(ADDRESS address)
{
  int tel;
  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)
#if 1
      if (
	  (address>=map_sections[tel].original_start && address<map_sections[tel].original_start+map_sections[tel].original_size)
	  )
#endif
	{
	  for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	    {
	      if ((address-tmp->original_start)>=0)
		if ((address-tmp->original_start)<tmp->size)
		  {
		    return tmp; 
		  }
	    }
	}
  //  printf("Locate Block : niet gevonden %lx !!!!!\n",address);
  return NULL;
}

/********************************************************
 return the section map of a certain type
 ********************************************************/
extern MAP_SECTION * LocateBlockSection(int type)
{
  int tel;
  for (tel=0; tel<numsections; tel++)
    if (map_sections[tel].type==type) return &map_sections[tel];
  return NULL;
}

MAP_SECTION map_sections[MAX_SECTIONS];

/********************************************************
 Parse the original or the relocated map file and build
 the map
 ********************************************************/

extern void ParseMap()
{
  char tmpstring[255];
  char currentsection[9];
  long tmplong;
  long nextstart;
  char * mapname = (char *) malloc (256);
  FILE * mapfp;
  MAP_BLOCK * tmp;

  strcpy(mapname,CONFIG_INFILE);
  strcat(mapname,".relocatemap");
  mapfp=fopen(mapname,"r");

  if (mapfp==NULL) 
    {
      strcpy(mapname,CONFIG_INFILE);
      strcat(mapname,".map");
      mapfp=fopen(mapname,"r");
      if (mapfp==NULL) 
	{
	  printf("Map not found\n");
	  return;
	}
    }

  /* Skip Header */
  do
    {
      fscanf(mapfp,"%s\n",tmpstring);
    } 
  while (tmpstring[0]!='.');

  do
    {
      /* New section */
      map_sections[numsections].type=nametranslate(tmpstring);
      fscanf(mapfp,"%lx\n",&tmplong);
      map_sections[numsections].start=tmplong;
      map_sections[numsections].original_start=tmplong;
      map_sections[numsections].new_start=map_sections[numsections].start;
      map_sections[numsections].dead_start=-1;
      fscanf(mapfp,"%lx\n",&tmplong);
      map_sections[numsections].size=tmplong;
      map_sections[numsections].new_size=tmplong;
      map_sections[numsections].original_size=tmplong;
      map_sections[numsections].dead_size=0;
      strcpy(currentsection, tmpstring);
      map_sections[numsections].first=NULL;
      map_sections[numsections].last=NULL;

      fscanf(mapfp,"%s\n",tmpstring);
      if (!feof(mapfp))
	do
	  {
	    if (strcmp(tmpstring,currentsection)!=0) break;
	    tmp=(MAP_BLOCK *) malloc(sizeof(MAP_BLOCK));
	    if (!tmp) exit(0);
	    tmp->data=NULL;
	    tmp->next=NULL;
	    tmp->map=NULL;
	    tmp->otf_map=NULL;
	    tmp->otf=NULL;
	    tmp->status=(char) 0xff;
	    tmp->otf_status=(char) 0xff;
	    if (map_sections[numsections].first==NULL) 
	      {
		
		map_sections[numsections].first=tmp;
		map_sections[numsections].last=tmp;
		nextstart=map_sections[numsections].start;
	      }
	    else
	      {
		nextstart=map_sections[numsections].last->start+map_sections[numsections].last->size;
		map_sections[numsections].last->next=tmp;
		map_sections[numsections].last=tmp;
	      }
	    if (strcmp(currentsection,".lit8")==0)
	      tmplong=nextstart;
	    else if (strcmp(currentsection,".lit4")==0)
	      tmplong=nextstart;
	    else
	      fscanf(mapfp,"%lx\n",&tmplong);
	    tmp->start=tmplong;
	    tmp->original_start=tmp->start;
	    tmp->attrib=0;
	    tmp->new_start=tmplong;
	    fscanf(mapfp,"%lx\n",&tmplong);
	    tmp->size=tmplong;
	    fscanf(mapfp,"%s\n",tmpstring);
	    fscanf(mapfp,"%s\n",tmpstring);
	    if (tmpstring[0]!='.')
	      {
		tmp->attrib=atoi(tmpstring);
		fscanf(mapfp,"%s\n",tmpstring);
	      }
	    if (feof(mapfp)) break;
	  } 
	while (1);
      
      if ( map_sections[numsections].type == R_SN_PDATA)
	{
	  long run=0;
	  for (tmp=map_sections[numsections].first; tmp->next!=NULL; tmp=tmp->next)
	    {
	      tmp->size=tmp->next->start-tmp->start;
	      run+=tmp->size;
	    }
	  map_sections[numsections].last->size=map_sections[numsections].size-run;
	  // Het laatste blokje krijgt de padding van de sectie mee op deze manier !!!!!!!!!!!
	}
      if ( map_sections[numsections].type == R_SN_BSS)
	{
	  long run=0;
	  for (tmp=map_sections[numsections].first; tmp!=NULL; tmp=tmp->next)
	    {
	      run+=tmp->size;
	    }
	  tmp=(MAP_BLOCK *) malloc(sizeof(MAP_BLOCK));
	  if (!tmp) exit(0);
	  tmp->next=NULL;
	  tmp->size=map_sections[numsections].size-run;
	  tmp->data=NULL;
	  tmp->map=NULL;
	  tmp->otf_map=NULL;
	  tmp->otf=NULL;
	  tmp->attrib=0;
	  tmp->status= (char) 0xff;
	  tmp->otf_status=(char) 0xff;
	  tmp->start=tmp->new_start=map_sections[numsections].start+run;
	  tmp->original_start=tmp->start;
	  map_sections[numsections].last->next=tmp;
	  map_sections[numsections].last=tmp;
	}
      if ( map_sections[numsections].type == R_SN_SBSS)
	{
	  long run=0;
	  for (tmp=map_sections[numsections].first; tmp!=NULL; tmp=tmp->next)
	    {
	      run+=tmp->size;
	    }
	  tmp=(MAP_BLOCK *) malloc(sizeof(MAP_BLOCK));
	  if (!tmp) exit(0);
	  tmp->next=NULL;
	  tmp->size=map_sections[numsections].size-run;
	  tmp->attrib=0;
	  tmp->data=NULL;
	  tmp->map=NULL;
	  tmp->otf_map=NULL;
	  tmp->otf=NULL;
	  tmp->status= (char) 0xff;
	  tmp->otf_status=(char) 0xff;
	  tmp->start=tmp->new_start=map_sections[numsections].start+run;
	  tmp->original_start=tmp->start;
	  map_sections[numsections].last->next=tmp;
	  map_sections[numsections].last=tmp;
	}
	    
    
      numsections++;
    } 
  while (!feof(mapfp));

  fclose(mapfp);

  if (ASEC_SIZE(BIN_SECTION_MAP[R_SN_INIT])!=ASEC_SIZE(BIN_SECTION_MAP[R_SN_TEXT])) // QUICK HACK for non-existent fini and init
    {
      map_sections[numsections].type=nametranslate(".init");
      map_sections[numsections].start=ASEC_START(BIN_SECTION_MAP[R_SN_INIT]);
      printf("%lx\n",ASEC_SIZE(BIN_SECTION_MAP[R_SN_INIT]));
      map_sections[numsections].new_start=ASEC_START(BIN_SECTION_MAP[R_SN_INIT]);
      map_sections[numsections].original_start=ASEC_START(BIN_SECTION_MAP[R_SN_INIT]);
      map_sections[numsections].size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_INIT]);
      map_sections[numsections].new_size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_INIT]);
      map_sections[numsections].original_size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_INIT]);
      map_sections[numsections].last=(MAP_BLOCK *) malloc(sizeof(MAP_BLOCK));
      map_sections[numsections].first=map_sections[numsections].last;
      tmp= map_sections[numsections].first;
      if (!tmp) exit(0);
      tmp->next=NULL;
      tmp->map=NULL;
      tmp->otf_map=NULL;
      tmp->otf=NULL;
      tmp->data=NULL;
      tmp->attrib=0;
      tmp->status= (char) 0xff;
      tmp->otf_status=(char) 0xff;
      tmp->start=map_sections[numsections].start;
      tmp->new_start=map_sections[numsections].start;
      tmp->original_start=tmp->new_start;
      tmp->size=map_sections[numsections].size;
      numsections++;
      map_sections[numsections].type=nametranslate(".fini");
      map_sections[numsections].start=ASEC_START(BIN_SECTION_MAP[R_SN_FINI]);
      map_sections[numsections].new_start=ASEC_START(BIN_SECTION_MAP[R_SN_FINI]);
      map_sections[numsections].original_start=ASEC_START(BIN_SECTION_MAP[R_SN_FINI]);
      map_sections[numsections].size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_FINI]);
      map_sections[numsections].original_size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_FINI]);
      map_sections[numsections].new_size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_FINI]);
      map_sections[numsections].last=(MAP_BLOCK *) malloc(sizeof(MAP_BLOCK));
      map_sections[numsections].first=map_sections[numsections].last;
      tmp= map_sections[numsections].first;
      if (!tmp) exit(0);
      tmp->next=NULL;
      tmp->data=NULL;
      tmp->attrib=0;
      tmp->map=NULL;
      tmp->otf_map=NULL;
      tmp->otf=NULL;
      tmp->status= (char) 0xff;
      tmp->otf_status=(char) 0xff;
      tmp->start=map_sections[numsections].start;
      tmp->new_start=map_sections[numsections].start;
      tmp->original_start=tmp->new_start;
      tmp->size=map_sections[numsections].size;
      numsections++;
    }
  map_sections[numsections].type=nametranslate(".lita");
  map_sections[numsections].start=ASEC_START(BIN_SECTION_MAP[R_SN_LITA]);
  map_sections[numsections].new_start=ASEC_START(BIN_SECTION_MAP[R_SN_LITA]);
  map_sections[numsections].original_start=ASEC_START(BIN_SECTION_MAP[R_SN_LITA]);
  map_sections[numsections].size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_LITA]);
  map_sections[numsections].original_size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_LITA]);
  map_sections[numsections].new_size=ASEC_SIZE(BIN_SECTION_MAP[R_SN_LITA]);
  map_sections[numsections].first=NULL;
  map_sections[numsections].last=NULL;
  {
    char* litamapname =  (char *) malloc (256);
    FILE * fp;
    long address;
    char on;
    strcpy(litamapname,CONFIG_INFILE);
    strcat(litamapname,".litamap");
    fp=fopen(litamapname,"r");
    dead_lita_size = 0L;
    for (address= map_sections[numsections].start; address< map_sections[numsections].start + map_sections[numsections].size; address+=8)
      {
	if (fp)
	  fscanf(fp, "%c",&on);
	else
	  on='1';
	tmp=(MAP_BLOCK *) malloc(sizeof(MAP_BLOCK));
	if (!tmp) exit(0);
	tmp->next=NULL;
	tmp->data=NULL;
	tmp->map=NULL;
	tmp->otf_map=NULL;
	tmp->otf=NULL;
	tmp->status= (char) 0xff;
	tmp->otf_status=(char) 0xff;
	if (on=='0')
	  {
	    dead_lita_size+=8;
	    tmp->attrib=-1;
	  }
	else if (on=='1')
	  {
	    tmp->attrib=0;
	  }
	
	tmp->start=address;
	tmp->new_start=tmp->start;
	tmp->original_start=tmp->new_start;
	tmp->size=8;
	if (map_sections[numsections].first==NULL) 
	  {
	    map_sections[numsections].first=tmp;
	    map_sections[numsections].last=tmp;
	  }
	else
	  {
	    map_sections[numsections].last->next=tmp;
	    map_sections[numsections].last=tmp;
	  }
	
      }
    if (fp)
      fclose(fp);
  }
  numsections++;

  InfoStatus(stdout,"\t[ParseMap]\n");
}

/********************************************************
 print a section's data
 ********************************************************/
void PrintSection(int type)
{
  MAP_BLOCK * tmp;
  int tel;
  for (tel=0; tel<numsections; tel++)
    {
      if (map_sections[tel].type!=type) continue;
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  printf("%lx: %lx\n",tmp->start,ReadData64(tmp->start));
	}
    }
}
#undef __PROC__
#define __PROC__ "PrintBlock"

/********************************************************
 print a block's data
 ********************************************************/
extern void PrintBlock(MAP_BLOCK * block)
{
  long tel;
  for (tel=block->start;tel<block->start+block->size;tel+=8)
    {
      printf("%lx: %8x %8x\n",tel,ReadData32(tel),ReadData32(tel+4));
    }
}

/********************************************************
 read the data into a data block and do some initializations
 ********************************************************/
extern void ReadBlocks()
{
  int tel,tel2;
  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)
    {
      INDEX isec;
      if ((map_sections[tel].type==R_SN_SBSS)||(map_sections[tel].type==R_SN_BSS))
	{
	  for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	    {
	      tmp->map=(char *) malloc(sizeof(char)*tmp->size/8+1);
	      tmp->otf_map=(char *) malloc(sizeof(char)*tmp->size/8+1);
	      for (tel2=0; tel2<tmp->size; tel2+=8)
		{
		  tmp->map[tel2/8]=(char) (0xff & ~IS_JUMP_TARGET);
		  tmp->otf_map[tel2/8]=(char) (0xff & ~IS_JUMP_TARGET);
		}
	      
	    }
	  
	}
      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
      isec=BIN_SECTION_MAP[map_sections[tel].type];
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  tmp->data=(char *) malloc(sizeof(char)*tmp->size);
	  tmp->map=(char *) malloc(sizeof(char)*tmp->size/8+1);
	  tmp->otf_map=(char *) malloc(sizeof(char)*tmp->size/8+1);
	  for (tel2=0; tel2<tmp->size; tel2+=8)
	    {
	      tmp->map[tel2/8]=(char) (0xff & ~IS_JUMP_TARGET);
	      tmp->otf_map[tel2/8]=(char) (0xff & ~IS_JUMP_TARGET);
	    }
	  bcopy(ASEC_DATA8(isec)+tmp->start-ASEC_START(isec),tmp->data,tmp->size);
	}
    }

  InfoStatus(stdout,"\t[ReadBlocks]\n");

}

/********************************************************
 return the new type of an old-style section
 ********************************************************/

int sec_type(INDEX isec)
{
  return nametranslate(ASEC_NAME(isec));
}

/********************************************************
 apply a literal relocation on the moved data
 ********************************************************/

void do_literal(INDEX isec, INDEX irel)
{
  ADDRESS addr;
  STRUCT_INS i;
  MAP_BLOCK * tmp;
  Disassemble(ReadData32(ASEC_AREL_ADDRESS(isec,irel)),&i);
  if (i.RegB!=29) 
    {
      printf("%lx\n",ASEC_AREL_ADDRESS(isec,irel));
      printf("Literal reloc not from gp!!!!!\n");
      exit(0);
    }
  addr=BIN_GP+i.Data;
  tmp=LocateOriginalBlock(addr);
  addr+=tmp->new_start-tmp->start;
  i.Data=addr - new_gp;
  WriteData32(ASEC_AREL_ADDRESS(isec,irel),Assemble(&i));
  Disassemble(ReadData32(ASEC_AREL_ADDRESS(isec,irel)),&i);
}
/********************************************************
 apply a gp-displacement relocation on the moved data
 ********************************************************/

void do_gpdisp(INDEX isec, INDEX irel)
{
  STRUCT_INS i1;
  STRUCT_INS i2;
  MAP_BLOCK * tmp;
   
  long result;
  
  int lo, hi;
  Disassemble(ReadData32(ASEC_AREL_ADDRESS(isec,irel)),&i1);
  Disassemble(ReadData32(ASEC_AREL_ADDRESS(isec,irel)+ASEC_AREL_SYMBOL(isec,irel)),&i2);
  tmp=LocateOriginalBlock(ASEC_AREL_ADDRESS(isec,irel));
  result = (BIN_GP - new_gp) + (tmp->start - tmp->new_start) + (65536 * i1.Data) + i2.Data;
  lo = result & 0xffff;
  hi = (result>>16);
  if (lo & 0x8000)
    {
      hi+=1;
      lo|=0xffff0000; 
    }
  i1.Data=hi;
  i2.Data=lo;
  WriteData32(ASEC_AREL_ADDRESS(isec,irel),Assemble(&i1));
  WriteData32(ASEC_AREL_ADDRESS(isec,irel)+ASEC_AREL_SYMBOL(isec,irel),Assemble(&i2));
    
}

static long stack[20];
static int top=0;

/********************************************************
 execute a push relocation
 ********************************************************/
void do_push(INDEX isec, INDEX irel)
{
  if (ASEC_AREL_EXTERN(isec,irel))
    {
      //      printf("External Push\n");
      exit(0);
    }
  else
    {
      MAP_BLOCK * block_tmp;
      block_tmp=LocateOriginalBlock(ASEC_AREL_ADDRESS(isec,irel));
      stack[top]=ASEC_AREL_ADDRESS(isec,irel);
      stack[top]+=block_tmp->new_start-block_tmp->start;
    }
  top++;
}
/********************************************************
 execute a sub relocation
 ********************************************************/

void do_psub(isec, irel)
{
  if (!ASEC_AREL_EXTERN(isec,irel))
    {
      //      printf("external psub\n");
      stack[top-1] -= AESY_VALUE(ASEC_AREL_SYMBOL(isec,irel));
    }
  else
    {
      MAP_SECTION * scn_tmp;
      MAP_BLOCK * block_tmp;
      //      printf("Local Psub\n");
      //      scn_tmp=LocateBlockSection(ASEC_AREL_SYMBOL(isec,irel));
      block_tmp=LocateOriginalBlock(/*scn_tmp->original_start+*/ASEC_AREL_ADDRESS(isec,irel));
      stack[top-1]-=ASEC_AREL_ADDRESS(isec,irel);
      stack[top-1]-=block_tmp->new_start-block_tmp->start;
    }
}

void do_prshift(isec,irel)
{
  ADDRESS result;

  if (ASEC_AREL_EXTERN(isec,irel))
    {
      //      printf("external prshift\n");
      stack[top-1] >>= AESY_VALUE(ASEC_AREL_SYMBOL(isec,irel));
    }
  else
    {
      MAP_SECTION * scn_tmp;
      MAP_BLOCK * block_tmp;
      //      printf("Local prshift\n");
      if (ASEC_AREL_SYMBOL(isec,irel)==R_SN_ABS)
	{
	  result = ASEC_AREL_ADDRESS(isec,irel);
	}
      else
	{
	  scn_tmp=LocateBlockSection(ASEC_AREL_SYMBOL(isec,irel));
	  block_tmp=LocateOriginalBlock(scn_tmp->original_start+ASEC_AREL_ADDRESS(isec,irel));
	  result = ASEC_AREL_ADDRESS(isec,irel)+block_tmp->new_start-block_tmp->start;
	}
      stack[top-1] >>= result;
    }
}

/********************************************************
 execute a store-relocation
 ********************************************************/

void do_store(isec,irel)
{
  INT64 bitfield;
  INT64 mask;
  --top;
  return;
  if (ASEC_AREL_EXTERN(isec,irel))
    {
      printf("External store\n");
      exit(0);
    }
  else
    {
      mask=((1L << ((long) ASEC_AREL_SIZE(isec,irel))) - 1L) <<  ASEC_AREL_OFFSET(isec,irel);
      bitfield = ((long) stack[--top]) & mask;

      //      bitfield = ((long) stack[--top] >> ASEC_AREL_OFFSET(isec,irel)) & (mask);
      WriteData64(ASEC_AREL_ADDRESS(isec,irel),bitfield | (ReadData64(ASEC_AREL_ADDRESS(isec,irel)) & ~mask));
    }
  
}

/********************************************************
 return new section end after relocation if address is old
 section end 
 ********************************************************/
ADDRESS IsSectionEnd(ADDRESS address, INDEX isec)
{
  if (address==ASEC_START(isec)+ASEC_SIZE(isec))
    {
      MAP_SECTION * tmp;
      tmp=LocateBlockSection(nametranslate(ASEC_NAME(isec)));
      return tmp->new_start+tmp->size;
    }
  return -1;
}
/********************************************************
 return new segment end if address is old segment end
 ********************************************************/
ADDRESS IsSegmentEnd(ADDRESS address)
{
  if (address==old_text_start+old_tsize)
    return new_text_start+new_tsize;
  if (address==old_bss_start+old_bsize)
    return new_bss_start+new_bsize;

  return -1;
}

/********************************************************
 apply a refquad relocation 
 ********************************************************/
void do_refquad(isec,irel)
{
  INT64 value;
  if (ASEC_AREL_EXTERN(isec,irel))
    {
      printf("External refquad\n");
      exit(0);
    }
  else
    {
      MAP_BLOCK * tmp;
      ADDRESS new;
      value=ReadData64(ASEC_AREL_ADDRESS(isec,irel));
      if (VALID(new=IsSectionEnd(value, BIN_SECTION_MAP[ASEC_AREL_SECTION(isec,irel)])))
	{
	  value=new;
	}
      else if (VALID(new=IsSegmentEnd(value)))
	{
	  value=new;
	}
      else
	{
	  tmp=LocateOriginalBlock(value);
	  if (tmp==NULL)
	    {
	      printf("Section number = %s at address value %lx\n",ASEC_NAME(ASEC_AREL_SECTION(isec,irel)),ASEC_AREL_ADDRESS(isec,irel));
	    }
	  value+=tmp->new_start-tmp->start;
	}
      WriteData64(ASEC_AREL_ADDRESS(isec,irel),value);
    }
}
/********************************************************
 apply a gp-relative relocation
 ********************************************************/

void do_gprel32(isec,irel)
{
  INT32 value;
  INT32 value_copy;
  INT64 value2;
  if (ASEC_AREL_EXTERN(isec,irel))
    {
      printf("External gprel32\n");
      exit(0);
    }
  else
    {
      MAP_BLOCK * tmp;
      value_copy=value=ReadData32(ASEC_AREL_ADDRESS(isec,irel));
      value2=((INT64) value)+BIN_GP;
      tmp=LocateOriginalBlock(value2);
      value2+=tmp->new_start-tmp->start;
      value=(INT32) (value2-new_gp);
      WriteData32(ASEC_AREL_ADDRESS(isec,irel),value);
    }
}
/********************************************************
 apply a gprellow relocation: is handled by do_gprelhigh
 ********************************************************/

void do_gprellow(isec,irel)
{
  return;
}
/********************************************************
 apply a gprelhigh relocation: handled by CreateRefQuadBlock()
 ********************************************************/
void do_gprelhigh(isec,irel)
{
  return;
}

/********************************************************
 apply an srel32 relocation
 ********************************************************/

void do_srel32(isec,irel)
{
  INT32 value;
  INT64 value2;
  if (ASEC_AREL_EXTERN(isec,irel))
    {
      printf("External srel32\n");
      exit(0);
    }
  else
    {
      MAP_BLOCK * tmp;
      value=ReadData32(ASEC_AREL_ADDRESS(isec,irel));
      value2=((INT64) value)+ASEC_AREL_ADDRESS(isec,irel);
      tmp=LocateOriginalBlock(value2);
      value2+=tmp->new_start-tmp->start;
      tmp=LocateBlock(ASEC_AREL_ADDRESS(isec,irel));
      value=value2-(ASEC_AREL_ADDRESS(isec,irel)+tmp->new_start-tmp->start);
      WriteData32(ASEC_AREL_ADDRESS(isec,irel),value);
    }
}

/********************************************************
 apply a relocation 
 ********************************************************/

static void do_reloc(INDEX isec, INDEX irel)
{
  switch(ASEC_AREL_TYPE(isec,irel))
    {
    case R_LITERAL:
      do_literal(isec,irel);
      break;
    case R_GPDISP:
      do_gpdisp(isec,irel);
      break;
    case R_ABS:
      //      printf("Abs\n");
      break;
    case R_OP_PUSH:
      do_push(isec,irel);
      break;
    case R_OP_PSUB:
      do_psub(isec,irel);
      break;
    case R_REFQUAD:
      do_refquad(isec,irel);
      break;
    case R_GPREL32:
      do_gprel32(isec,irel);
      break;
    case R_GPRELHIGH:
      do_gprelhigh(isec,irel);
      break;
    case R_GPRELLOW:
    case R_BRADDR:
    case R_LITUSE:
    case R_HINT:
    case R_IMMED:
      //      do_immed(isec,irel);
      break;
      // Niets bij doen
    case R_SREL32:
      do_srel32(isec,irel); 
      break;
    case R_OP_STORE:
      do_store(isec,irel);
      break;
    case R_OP_PRSHIFT:
      do_prshift(isec,irel);
      //      printf("Prshift\n");
      break;
    default:
      printf("Unknown Reloc: %d\n",ASEC_AREL_TYPE(isec,irel));
    }
}

/********************************************************
 update the address at which a relocation is to be performed
 ********************************************************/
void do_reloc_address(INDEX isec,INDEX irel)
{
  MAP_BLOCK * tmp;

  tmp=LocateOriginalBlock(ASEC_AREL_ADDRESS(isec,irel));
  if (tmp==NULL) return;
  ASEC_AREL_ADDRESS(isec,irel)+=tmp->new_start-tmp->start;

}
/********************************************************
 relocate the blocks
 ********************************************************/

extern void RelocateBlocks()
{
  INDEX isec;
  INDEX irel;
  INDEX is;
  int tel;
  MAP_BLOCK * tmp;

  FOREACH_ESY(is)  /* do external symbols */
    {
      if( (AESY_IS_PROC(is) || AESY_IS_LABEL(is)) && AESY_VALUE(is) != 0L )
        {
	  if (tmp=LocateOriginalBlock(AESY_VALUE(is)))
	    AESY_VALUE(is)+=tmp->new_start-tmp->start;
        }
    }

  FOREACH_LSY(is) /* do local symbols */
    {
      if( (ALSY_IS_PROC(is) || ALSY_IS_LABEL(is)) && ALSY_VALUE(is) != 0L )
        {
	  if (tmp=LocateOriginalBlock(ALSY_VALUE(is)))
	    ALSY_VALUE(is)+=tmp->new_start-tmp->start;
        }
    } 

  FOREACH_SEC(isec)
    {
      FOREACH_SEC_REL(isec,irel)
	{
	  do_reloc(isec,irel);	   
	  do_reloc_address(isec,irel);
	}
    }

  BIN_ENTRY+=LocateOriginalBlock(BIN_ENTRY)->new_start-LocateOriginalBlock(BIN_ENTRY)->start;

  for (tel=0; tel<numsections; tel++)
    {
      long run=0;
      /* Adapt blocksections */
      map_sections[tel].start=map_sections[tel].new_start;
      /* Adapt blocks */
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  tmp->start=tmp->new_start;
	  run+=tmp->size;
	}
      /* Adapt section headers */
      ASEC_START(BIN_SECTION_MAP[map_sections[tel].type])=map_sections[tel].start;
      ASEC_STARTP(BIN_SECTION_MAP[map_sections[tel].type])=map_sections[tel].start;
      if ((ASEC_START(BIN_SECTION_MAP[map_sections[tel].type])>=BIN_AOUTHDR.text_start) && (ASEC_START(BIN_SECTION_MAP[map_sections[tel].type])<BIN_AOUTHDR.data_start) )
	{
	  ASEC_SCNHDR(BIN_SECTION_MAP[map_sections[tel].type]).s_scnptr=ASEC_START(BIN_SECTION_MAP[map_sections[tel].type])-BIN_AOUTHDR.text_start;
	}
      ASEC_SIZE(BIN_SECTION_MAP[map_sections[tel].type])=map_sections[tel].new_size;
      map_sections[tel].size=map_sections[tel].new_size; // VERANDERING
    }

  BIN_GP=new_gp;

  InfoStatus(stdout,"\t[RelocateBlocks]\n");
}

/********************************************************
 giving the relocatemap file that is parsed, calculate
 the new starting addresses of blocks and sections
 ********************************************************/


extern void CalcNewBlockAddresses()
{
  INDEX isec;
  INDEX isec_max=0;
  int teller;
  int teller2;
  MAP_BLOCK* block;
  BOOL   verbose = HasOption(PRINT_OPT_VERBOSE,"Newaddress");

  FILE* gapfile;
  
  ADDRESS end_of_text = 0L;
  ADDRESS start_of_text;
  ADDRESS dead_data;
  long displacement;
  ADDRESS start_lita;
  ADDRESS end_of_data;
  char* jumpmapname =  (char *) malloc (256);

  gap=0x0L;
  old_bsize=0;
  old_tsize=0;
  strcpy(jumpmapname,CONFIG_INFILE);
  strcat(jumpmapname,".switchgap");

  gapfile=fopen(jumpmapname,"r");
  if (gapfile)
    {
      fscanf(gapfile,"%lx\n",&gap);
      if (verbose)
	printf("reading gap of %lx\n",gap);
    }
  fclose(gapfile);

  gap = (gap+0xfL) & ~0xfL;

  FOREACH_SEC(isec)
    {
      if (ASEC_START(isec)<BIN_AOUTHDR.data_start && ASEC_START(isec)>end_of_text)
	{
	  isec_max=isec;
	  end_of_text = ASEC_START(isec);
	}
      if (ASEC_START(isec)>=BIN_AOUTHDR.data_start && isec!=BIN_SECTION_MAP[R_SN_BSS] && isec!=BIN_SECTION_MAP[R_SN_SBSS] )
	{
	  old_dsize += ASEC_SIZE(isec);
	}
      if (isec==BIN_SECTION_MAP[R_SN_BSS] || isec==BIN_SECTION_MAP[R_SN_SBSS] )
	{
	  old_bsize += ASEC_SIZE(isec);
	}
    }

  end_of_text += ASEC_SIZE(isec_max) + 0x100L;
  old_tsize=end_of_text-BIN_AOUTHDR.text_start -  0x100L;
  old_text_start=BIN_AOUTHDR.text_start;
  old_data_start=BIN_AOUTHDR.data_start;
  old_bss_start=BIN_AOUTHDR.bss_start;

  // werkt momenteel enkel op linked list in volgorde van adres!
  
  //  aanpassen grote alle secties en verplaatsen dode blokken

  start_of_text = BIN_AOUTHDR.text_start+ sizeof(FILHDR) + sizeof(AOUTHDR) + BIN_NSECTIONS * sizeof(SCNHDR);
  start_of_text = (start_of_text+0xf) & ~0xf;   
  
  start_lita = start_of_text-dead_lita_size;
  dead_data = end_of_text+0x1000000; // try to avoid loosing live blocks
  dead_const_data = start_lita;
  
  for (teller=0;teller<numsections;teller++)
    {
      map_sections[teller].dead_start=-1L;
      if (map_sections[teller].type == R_SN_LITA && dead_lita_size!=0)
	map_sections[teller].dead_start = start_lita;
      
      block = map_sections[teller].first;
      displacement = 0L;
      map_sections[teller].new_size=map_sections[teller].size;
      map_sections[teller].dead_size=0L;
      while (block)
	{
	  if (block->attrib<0)
	    { 
	      if (map_sections[teller].type == R_SN_LITA)
		{
		  block->new_start=start_of_text-dead_lita_size;
		  dead_lita_size-=8;
		}
	      else if (map_sections[teller].type == R_SN_RCONST ||
		       map_sections[teller].type == R_SN_RDATA  ||
		       map_sections[teller].type == R_SN_LIT4   ||
		       map_sections[teller].type == R_SN_LIT8   ||
		       map_sections[teller].type == R_SN_PDATA)
		{
		  block->new_start=dead_const_data-block->size;
		  map_sections[teller].dead_start = block->new_start;
		  dead_const_data-=block->size;
		}
	      else
		{
		  if (!VALID(map_sections[teller].dead_start))
		    map_sections[teller].dead_start = dead_data;
		  block->new_start = dead_data;
		  dead_data+=block->size;
		}
	      displacement+=block->size;
	      map_sections[teller].new_size-=block->size;
	      map_sections[teller].dead_size+=block->size;
	    }
	  else
	    {
	      block->new_start -= displacement;
	    }
	  block=block->next;
	}

      if (verbose)
	printf("section %d %7s: old start %lx old size %5lx start %lx size %5lx dead_start %lx dead_size %5lx\n",
	       teller,
	       ASEC_NAME(BIN_SECTION_MAP[map_sections[teller].type]),
	       map_sections[teller].original_start,
	       map_sections[teller].original_size,
	       map_sections[teller].new_start,
	       map_sections[teller].new_size,
	       map_sections[teller].dead_start,
	       map_sections[teller].dead_size
	       );
    }
  
  // AANPASSING STARTADRESSEN SECTIES IN DATASEGMENT
 
  new_bss_start=0;
  new_bsize=0;

  for (teller=0;teller<numsections;teller++)
    {
      if (map_sections[teller].start<BIN_AOUTHDR.data_start) continue;

      for (teller2=0;teller2<numsections;teller2++)
	{
	  if (map_sections[teller2].start>=map_sections[teller].start) continue;
	  if (map_sections[teller2].start<BIN_AOUTHDR.data_start) continue;
	  map_sections[teller].new_start-=map_sections[teller2].size-map_sections[teller2].new_size;
	}

      if (map_sections[teller].start>=old_data_start+old_dsize) 
	{
	  new_bsize+=map_sections[teller].new_size;
	  continue;
	}

      if (new_bss_start<map_sections[teller].new_start+map_sections[teller].new_size)
	{
	  new_bss_start=map_sections[teller].new_start+map_sections[teller].new_size;
	}
    } 

  end_of_data = 0;

  for (teller=0;teller<numsections;teller++)
    {
      if (map_sections[teller].start<BIN_AOUTHDR.data_start) continue;
      map_sections[teller].new_start+=gap;
      if (map_sections[teller].new_start>=new_bss_start+gap) continue;
      if (map_sections[teller].new_start+map_sections[teller].new_size > end_of_data)
	{
	  end_of_data = map_sections[teller].new_start+map_sections[teller].new_size;
	}
      
    }
  
  new_data_start=BIN_AOUTHDR.data_start+gap;
  new_dsize=-new_data_start+((end_of_data+0x1fff) & ~0x1fff);
  new_bss_start+=gap;

  new_bsize-=((end_of_data+0x1fff) & ~0x1fff) - end_of_data;
  new_bss_start=((new_bss_start+0x1fff) & ~0x1fff); 

  BIN_AOUTHDR.dsize=new_dsize;

  // AANPASSING STARTADDRESSEN NIET-CODE SECTIES IN TEXTSEGMENT

  start_of_text = BIN_AOUTHDR.text_start+ sizeof(FILHDR) + sizeof(AOUTHDR) + BIN_NSECTIONS * sizeof(SCNHDR);
  start_of_text = (start_of_text+0xf) & ~0xf;   

  for (teller=0;teller<numsections;teller++)
    {
      if (map_sections[teller].start>=BIN_AOUTHDR.data_start) continue;
      if (map_sections[teller].type != R_SN_LITA) continue;
      
      map_sections[teller].new_start=start_of_text;
      start_of_text+=map_sections[teller].new_size;
    } 
 
  start_of_text = (start_of_text+0xf) & ~0xf;   
 
  for (teller=0;teller<numsections;teller++)
    {
      if (map_sections[teller].start>=BIN_AOUTHDR.data_start) continue;
      if (map_sections[teller].type == R_SN_FINI ||
	  map_sections[teller].type == R_SN_INIT ||
	  map_sections[teller].type == R_SN_LITA ||
	  map_sections[teller].type == R_SN_TEXT)
	continue;
      
      map_sections[teller].new_start=start_of_text;
      start_of_text+=map_sections[teller].new_size;      
      start_of_text = (start_of_text+0xf) & ~0xf;   
    } 

  start_of_text = (start_of_text+0xf) & ~0xf;   

  // AANPASSING STARTADDRESSEN CODE SECTIES IN TEXTSEGMENT

  for (teller=0;teller<numsections;teller++)
    {
      if (map_sections[teller].start>=BIN_AOUTHDR.data_start) continue;
      if (map_sections[teller].type != R_SN_FINI &&
	  map_sections[teller].type != R_SN_INIT &&
	  map_sections[teller].type != R_SN_TEXT)
	continue;
      
      map_sections[teller].new_start=start_of_text;
      //      map_sections[teller].first->new_start=start_of_text;//VERANDERING
      start_of_text+=map_sections[teller].new_size;      
    } 
  
  new_tsize=start_of_text-BIN_AOUTHDR.text_start;
  new_text_start= BIN_AOUTHDR.text_start;

  // AANPASSEN ADRESSEN BLOKKEN AAN NIEUWE STARTADRESSEN SECTIES

  for (teller=0;teller<numsections;teller++)
    {
      block = map_sections[teller].first;
      displacement = map_sections[teller].new_start-map_sections[teller].start;
      if (verbose)
	printf("displacement %s: %lx\n",ASEC_NAME(BIN_SECTION_MAP[map_sections[teller].type]),displacement);
      while (block)
	{
	  if (block->attrib>=0)
	    {
	      block->new_start+=displacement;
	    }
	  block=block->next;
	}
    }
  
 
  new_gp=start_lita+32768;
  BIN_AOUTHDR.data_start=new_data_start;

  InfoStatus(stdout,"\t[CalcNewBlockAddresses] old gp %lx new gp %lx\n",BIN_GP,new_gp);

}

/********************************************************
 from the data in the datablocks, reconstruct the data
 for the binary to be produced
 ********************************************************/

extern void BuildData()
{
  int tel;
  MAP_BLOCK * tmp;
  long run;
  MAP_SECTION* section = LocateBlockSection(R_SN_DATA);
  MAP_BLOCK * block = (MAP_BLOCK *) malloc (sizeof(MAP_BLOCK));
  FILE * gapfile;
  int gap;
  char* jumpmapname =  (char *) malloc (256);
  BOOL   verbose = HasOption(PRINT_OPT_VERBOSE,"Builddata");

  section = LocateBlockSection(R_SN_DATA);

  strcpy(jumpmapname,CONFIG_INFILE);
  strcat(jumpmapname,".switchgap");
  gapfile = fopen(jumpmapname,"w");
  
  gap = 0x1fff-(section->start&0x1fff);

  if (gap == 0x1fff) gap = 0;

  fprintf(gapfile,"%lx",gap);
  fclose(gapfile);  

  block->size=section->start&0x1fff;
  block->attrib=0;
  block->start=section->start-block->size;
  block->original_start=-1;
  block->new_start=block->start;
  block->next=section->first;
  block->status=(char) 0xff;
  block->otf_status=(char) 0xff;
  block->data = (char*) calloc(block->size,1);
  block->map  = (char*) malloc(block->size/8+1);
  block->otf_map  = (char*) malloc(block->size/8+1);
  
  section->first=block;
  section->size+=block->size;
  section->new_size+=block->size;
  section->start-=block->size;
  section->new_start-=block->size;
  ASEC_START(BIN_SECTION_MAP[R_SN_DATA])-=block->size;
  ASEC_STARTP(BIN_SECTION_MAP[R_SN_DATA])-=block->size;
  ASEC_SIZE(BIN_SECTION_MAP[R_SN_DATA])+=block->size;
  BIN_AOUTHDR.dsize+=block->size;
  BIN_AOUTHDR.data_start-=block->size;
  BIN_AOUTHDR.bsize=new_bsize;
  BIN_AOUTHDR.bss_start=new_bss_start;

  if (verbose)
    printf("added padding: %lx bytes\n",block->size);
  for (tel=0; tel<numsections; tel++)
    {
      INDEX isec;
      run=0;

      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) 
	continue; 
      isec=BIN_SECTION_MAP[map_sections[tel].type];
      if (ASEC_IS_PDATA(isec))
	{
	  ASEC_SCNHDR(isec).s_lnnoptr=map_sections[tel].new_size/8;
	}
      free(ASEC_DATA8(isec));
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	run+=tmp->size;	
      ASEC_DATA8(isec)=(INT8 *) calloc(ASEC_SIZE(isec),sizeof(INT8));
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next) 
	{
	  if (tmp->attrib<0) continue;
	  if (tmp->start-ASEC_START(isec)>ASEC_SIZE(isec))
	    {
	      if (tmp->start>new_text_start)
		printf("Blocks not right!!! size: %lx start: %lx blockstart: %lx orig_start: %lx\n",ASEC_SIZE(isec),ASEC_START(isec),tmp->start,map_sections[tel].start);
	      continue;
	    }
	  if (tmp->start-ASEC_START(isec)<0)
	    {
	      if (tmp->start>new_text_start)
		printf("Blocks not right!!! size: %lx start: %lx blockstart: %lx orig_start: %lx\n",ASEC_SIZE(isec),ASEC_START(isec),tmp->start,map_sections[tel].start);
	      continue;
	    }
	  
	  bcopy(tmp->data,ASEC_DATA8(isec)+tmp->start-ASEC_START(isec),tmp->size);
	}
      
    }
  InfoStatus(stdout,"\t[BuildData]\n");

}

/********************************************************
 generate the relocatemap file
 ********************************************************/


extern void GenerateMapFile()
{
  char tmpstring[255];
  char currentsection[9];
  long tmplong;
  long nextstart;
  char* mapname =  (char *) malloc (256);
  char* relocmapname =  (char *) malloc (256);
  FILE* mapfp;
  FILE* relocmapfp;
  BOOL verbose = HasOption(PRINT_OPT_VERBOSE,"Genmap");
  MAP_BLOCK * tmp;

  strcpy(mapname,CONFIG_INFILE);
  strcat(mapname,".map");

  strcpy(relocmapname,CONFIG_INFILE);
  strcat(relocmapname,".relocatemap");
  
  if (!FACTOR_DONE)
    {
      mapfp=fopen(mapname,"r");
      
      if (mapfp==NULL) 
	{
	  printf("Map not found\n");
	  return;
	}

      relocmapfp = fopen(relocmapname,"w");

      /* Skip Header */
      do
	{
	  fscanf(mapfp,"%s\n",tmpstring);
	  fprintf(relocmapfp,"%s\n",tmpstring);
	} 
      while (tmpstring[0]!='.');
      
      do
	{
	  /* New section */
	  fscanf(mapfp,"%lx\n",&tmplong);
	  fprintf(relocmapfp,"%lx ",tmplong);
	  nextstart=tmplong;
	  fscanf(mapfp,"%lx\n",&tmplong);
	  fprintf(relocmapfp,"%lx\n",tmplong);
	  strcpy(currentsection, tmpstring);
	  fscanf(mapfp,"%s\n",tmpstring);
	  if (!feof(mapfp))
	    do
	      {
		fprintf(relocmapfp,"%s ",tmpstring);
		if (strcmp(tmpstring,currentsection)!=0) break;
		if ((strcmp(currentsection,".lit4")==0)|| (strcmp(currentsection,".lit8")==0))
		  {
		    tmplong=nextstart;
		  }
		else
		  {
		    fscanf(mapfp,"%lx\n",&tmplong);
		    fprintf(relocmapfp,"%lx ",tmplong);
		  }
		tmp=LocateOriginalBlock(tmplong);
		fscanf(mapfp,"%lx\n",&tmplong);
		fprintf(relocmapfp,"%lx ",tmplong);
		nextstart+=tmplong;
		fscanf(mapfp,"%s\n",tmpstring);
		fprintf(relocmapfp,"%s ",tmpstring);
		fscanf(mapfp,"%s\n",tmpstring);
		if (tmpstring[0]!='.')
		  {
		    fscanf(mapfp,"%s\n",tmpstring);
		    fprintf(relocmapfp,"%d\n",tmp->attrib);
		  }
		else
		  {
		    fprintf(relocmapfp,"%d\n",tmp->attrib);
		  }
		if (feof(mapfp)) break;
	      } 
	    while (1);
	} 
      while (!feof(mapfp));

      fclose(mapfp);
      fclose(relocmapfp);
    }
  
  if (verbose)
    {
      MAP_BLOCK * block;
      int before_total = 0;    // total number of data
      int before_constant = 0; // total number of constant data
      int after_dead = 0;      // total number of dead data
      int after_constant = 0;  // total number of constant data after analysis
      int after_removable = 0; // total number of removable data
      int after_removed =0;    // total number of removed data
      ADDRESS address;
      BOOL seen_live;
      int  tmp_dead;
      INDEX isec;
      int section;
      int teller;

      for (section=0; section<numsections; section++)
	{
	  block = map_sections[section].first;
	  if (!block) continue;
	  address = block->start;
	  if (AddressIsCode(address)) continue;
	  isec = LocateSection(address);
	  if (ASEC_IS_BSS(isec) || ASEC_IS_SBSS(isec)) continue;

	  while (block)
	    {
	      before_total += block->size;
	      if (AsecIsReadOnly(isec) || AsecConstSectionContainsAddress(address))
		before_constant += block->size;

	      if (block->attrib == -1)
		after_removed += block->size;
	      
	      seen_live = 0;
	      tmp_dead = 0;

	      for (teller=0;teller<block->size;teller+=8)
		{
		  if (!(block->map[teller/8]&HAS_STORE))
		    after_constant+=8;

		  if (!(block->map[teller/8] & (HAS_STORE|HAS_LOAD)))
		    {
		      after_dead+=8;
		      if (block->attrib == 0) tmp_dead += 8;
		    }
		  else
		    {
		      if (!seen_live)
			after_removable += tmp_dead;
		      seen_live = 1;
		      tmp_dead = 0;
		    }
		}

	      if (block->attrib == 0) after_removable += tmp_dead;
	      block=block->next;
	    }
	}
      
      printf("total data                  %10d\n",before_total);
      printf("data in const section       %10d\n",before_constant);
      printf("const data                  %10d\n",after_constant);
      printf("dead data                   %10d\n",after_dead);
      printf("removable data              %10d\n",after_removable);
      printf("removed data                %10d\n",after_removed);
    }
}
#define BITS_OPC(n)   ((n>>26) & 0x3f)
#define MAKE_OPC(n)   ((n & 0x3f) << 26)
#define BITS_FFUN(n)  ((n>>5)  & 0x7ff)
#define MAKE_FFUN(n)  ((n & 0x7ff) << 5)
#define BITS_IFUN(n)  ((n>>5)  & 0x7f) 
#define MAKE_IFUN(n)  ((n & 0x7f) << 5)
#define BITS_MFUN(n)  (n & 0xffff)
#define MAKE_MFUN(n)  (n & 0xffff)
#define BITS_JFUN(n)  ((n>>14) & 0x3)
#define MAKE_JFUN(n)  ((n & 0x3) << 14)
#define BITS_ISLIT(n) ((n>>12) & 0x1)
#define MAKE_LIT      (0x1<<12)
#define BITS_IMMED(n) ((n>>13) & 0xff)
#define MAKE_IMMED(n) ((n & 0xff)  << 13 )
#define BITS_REGC(n)  (n & 0x1f)
#define MAKE_REGC(n)  (n & 0x1f)
#define BITS_REGB(n)  ((n>>16) & 0x1f)
#define MAKE_REGB(n)  ((n & 0x1f) << 16)
#define BITS_REGA(n)  ((n>>21) & 0x1f)
#define MAKE_REGA(n)  ((n & 0x1f) << 21)
#define BITS_BDISP(n) (n & 0x1fffff)
#define MAKE_BDISP(n) (n & 0x1fffff)
#define BITS_BSIGN(n) (n & 0x100000)                       
#define BITS_MDISP(n) (n & 0xffff)
#define MAKE_MDISP(n) (n & 0xffff)
#define BITS_MSIGN(n) (n & 0x8000)                                              
#define BITS_PAL(n)   (n & 0x3ffffff)
#define MAKE_PAL(n)   (n & 0x3ffffff)
#define BITS_HINT(n)  (n & 0x3fff)
#define MAKE_HINT(n)  (n & 0x3fff)

/***************************************************
 this procedure converts GP_RELHIGH and GPRELLOW instructions
 to instructions loading the address from the data section
 using refquads.
 ***************************************************/


MAP_BLOCK* CreateNewDataBlock(INT64 data)
{
  
  MAP_BLOCK* block;
  MAP_SECTION* section;

  block = (MAP_BLOCK *) malloc (sizeof(MAP_BLOCK));
  section = LocateBlockSection(R_SN_DATA);
  
  block->size=8;
  block->attrib=0;
  block->start=section->start-block->size;
  block->original_start=block->start;
  block->new_start=section->new_start-block->size;
  block->next=section->first;
  block->status=(char) 0xff;
  block->otf_status=(char) 0xff;
  block->data = (char*) calloc(block->size,1);
  block->map  = (char*) calloc(block->size/8,1);
  block->otf_map  = (char*) calloc(block->size/8,1);
  block->otf  = NULL;
  
  section->first=block;
  section->size+=block->size;
  section->new_size+=block->size;
  section->original_size+=block->size;
  section->start-=block->size;   
  section->new_start-=block->size;
  section->original_start-=block->size; 
  ASEC_STARTP(BIN_SECTION_MAP[R_SN_DATA])-=block->size;
  ASEC_START(BIN_SECTION_MAP[R_SN_DATA])-=block->size;
  ASEC_SIZE(BIN_SECTION_MAP[R_SN_DATA])+=block->size;
  BIN_AOUTHDR.dsize+=block->size;
  BIN_AOUTHDR.data_start-=block->size;
  new_dsize+=block->size;
  new_data_start-=block->size;

  *((INT64*)block->data) = data;

  return block;

}

extern void CreateRefQuadBlock()
{
  MAP_BLOCK* block;
  MAP_SECTION* section;
  INT64 value;
  INT32 hi,lo;
  INDEX isec;
  INDEX irel;
  INDEX is;
  INT64 high_bits;
  INT64 low_bits; 
  INT64 address;
  int teller;
  int nt = 0, nc = 0;


  FOREACH_SEC(isec)    /* Do the Relocation Info */
    {
      FOREACH_SEC_REL(isec,irel)
        {
	  if( ASEC_AREL_EXTERN(isec,irel) )
	    continue;
	  
	  if (ASEC_AREL_TYPE(isec,irel)==R_GPRELHIGH || (ASEC_AREL_TYPE(isec,irel)==R_IMMED && ASEC_AREL_SIZE(isec,irel)==R_IMMED_GP_HI32))
	    {
	      //	      if (ASEC_AREL_TYPE(isec,irel)==R_GPRELHIGH) printf("GPRELHIGH\n");
	      //	      if (ASEC_AREL_TYPE(isec,irel)==R_IMMED && ASEC_AREL_SIZE(isec,irel)==R_IMMED_GP_HI32) printf("IMMED\n");

	      // 1) address moet in datasectie komen
	      
	      nt++;

	      high_bits = BITS_MDISP(ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel)-ASEC_START(isec))/4]);
	      if (BITS_MSIGN(high_bits))
		high_bits |= -1 ^ 0xffff;
	      low_bits  = BITS_MDISP(ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel+1)-ASEC_START(isec))/4]);
	      if (BITS_MSIGN(low_bits))
		low_bits |= -1 ^ 0xffff;
	      address = BIN_GP + high_bits * 65536L + low_bits;
	      
	      if (AddressIsCode(address) || 
		  HasOption(CONFIG_PROFILE_WHAT, "Bbl") ||
		  HasOption(CONFIG_PROFILE_WHAT, "Edg") ||
		  HasOption(CONFIG_PROFILE_WHAT, "Value") ||
		  HasOption(DISABLED_OPT,"Data")
		  )
		{
		  block = CreateNewDataBlock(address);
		  nc++;
		}
	      else
		{
		  block = (MAP_BLOCK *) malloc (sizeof(MAP_BLOCK));

		  section = 0;
		  for (teller=0;teller<numsections;teller++)
		    {
		      if (map_sections[teller].dead_start == dead_const_data)
			{
			  section = &(map_sections[teller]);
			  break;
			}
		    }

		  if (!section)
		    {
		      section = LocateBlockSection(R_SN_RCONST);
		      section->dead_start=dead_const_data;
		      section->dead_size=0;
		    }
		  
		  block->size=8;
		  block->attrib=0;
		  block->start=section->dead_start-block->size;
		  block->original_start=block->start;
		  block->new_start=section->dead_start-block->size;
		  block->next=section->first;
		  block->status=(char) 0xff;
		  block->otf_status=(char) 0xff;
		  block->data = (char*) calloc(block->size,1);
		  block->map  = (char*) calloc(block->size/8,1);
		  block->otf_map  = (char*) calloc(block->size/8,1);
		  block->otf  = NULL;

		  dead_const_data-=block->size;

		  section->first=block;
		  //		  section->size+=block->size;
		  section->dead_size+=block->size;
		  section->original_size+=block->size;
		  //		  section->start-=block->size;   
		  section->dead_start-=block->size;
		  section->original_start-=block->size; 
		}

	      *((INT64*)block->data) = address;
	      
	      // 2) bestaande relocatie wordt refquad op adress in data

	      is = BIN_SECTION_MAP[R_SN_DATA];

	      ASEC_NRELOCS(is)++;
	      ASEC_RELOC(is) = realloc(ASEC_RELOC(is),sizeof(RELOC)*ASEC_NRELOCS(is));
	      ASEC_AREL_EXTERN(is,ASEC_NRELOCS(is)-1)=0;
	      ASEC_AREL_SYMBOL(is,ASEC_NRELOCS(is)-1) = ASEC_AREL_SYMBOL(isec,irel+1);
	      ASEC_AREL_TYPE(is,ASEC_NRELOCS(is)-1)=R_REFQUAD;
	      ASEC_AREL_ADDRESS(is,ASEC_NRELOCS(is)-1)=block->start;
	      ASEC_AREL_OFFSET(is,ASEC_NRELOCS(is)-1)=0;

	      // 3) instructies worden ldah en ldq in ingelezen sectie, moet nog gedisassembleerd worden

	      value=block->new_start-new_gp;
	      hi = value >> 16;
	      lo = value & 0xffff;
	      if( lo & 0x8000 )
		{
		  lo |= 0xffff0000;
		  hi += 1;
		}

	      ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel)-ASEC_START(isec))/4] = 
		MAKE_OPC(0x9) +
		MAKE_REGA(BITS_REGA(ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel)-ASEC_START(isec))/4])) +
		MAKE_REGB(BITS_REGB(ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel)-ASEC_START(isec))/4])) +
		MAKE_MDISP(hi);

	      ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel+1)-ASEC_START(isec))/4] = 
		MAKE_OPC(0x29) +
		MAKE_REGA(BITS_REGA(ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel+1)-ASEC_START(isec))/4])) + 
		MAKE_REGB(BITS_REGB(ASEC_DATA32(isec)[(ASEC_AREL_ADDRESS(isec,irel+1)-ASEC_START(isec))/4])) +
		MAKE_MDISP(lo); 
	    }
	}
    }

  InfoStatus(stdout,"\t[CreateRefQuadBlock] total %d writable %d\n",nt,nc);

}
